<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>AJAX</title>
</head>
<body onload="getAndDisplayUsers()">
    
    <h1>AJAX</h1>
       
    <button>Add user</button>
    <ul id="users"></ul>

    <script>
        const usersApiUrl = '/fake-db/users.json';
        const userAddApiUrl = '/fake-db/user-add.json';
        const usersElement = document.querySelector('#users');
        const addButton = document.querySelector('button');
        addButton.addEventListener('click',addUser);

        function getAndDisplayUsers(){
            usersElement.innerHTML = '<li><em>loading users...</em></li>';

            fetch(usersApiUrl)
                .then(function(response) {
                    if (!response.ok) {
                        throw Error(response.statusText);
                    }
                    return response.json();
                })
                .catch(e => alert('Errore nel caricare gli utenti. ' + e))
                .then(function(users){
                    if(!users || users.length === 0) {
                        usersElement.innerHTML = '<em>no users</em>';
                        return;
                    }
                    usersElement.innerHTML = '';
                    // users.forEach(function(user){
                    //     usersElement.innerHTML += `<li>${user.id} - ${user.name} ${user.surname}</li>`;
                    // });
                    for(let i = 0; i < users.length; i++) {
                        let user = users[i];
                        usersElement.innerHTML += "<li>" + user.id + " - " + user.name + " " + user.surname + "</li>";
                    }
                    
                });
        }

        async function getAndDisplayUsersAsync(){
            
            usersElement.innerHTML = '<em>loading users...</em>';

            const users = await fetchUsersAsync(usersApiUrl).catch(e => alert('Errore nel caricare gli utenti. ' + e));
            
            if(!users) {
                usersElement.innerHTML = '<em>no users</em>';
                return;
            }
            
            usersElement.innerHTML = '';
            users.forEach(function(user){
                usersElement.innerHTML += `<li>${user.id} - ${user.name} ${user.surname}</li>`;
            });
        }

        function fetchUsersAsync(url){
            return fetch(url)
                .then(function(response) {
                    if (!response.ok) {
                        throw Error(response.statusText);
                    }
                    return response.json();
                });
        }

        async function addUser(){
            const user = await fetchUsersAsync(userAddApiUrl)
                    .catch(e => alert('Errore nel caricare l\'utente. ' + e));
            
            if(!user) {
                return;
            }
            usersElement.innerHTML += `<li>${user.id} - ${user.name} ${user.surname}</li>`;
            addButton.disabled = true;
        }
    </script>
</body>
</html>